<?PHP
// wcf imports
require_once(WCF_DIR.'lib/system/cache/CacheBuilder.class.php');
require_once(WCF_DIR.'lib/data/user/User.class.php');

/**
 * Caches the birthday list
 *
 * @package	com.woltlab.community.portal.birthday
 * @author	Alexander Ebert, Martin Schwendowius
 * @copyright	2009 WoltLab Community
 * @license	GNU Lesser Public License <http://www.gnu.org/licenses/lgpl.html>
 * @subpackage	system.cache
 * @category	Portal
 */
class CacheBuilderBirthdayList implements CacheBuilder {
	/**
	 * @see CacheBuilder::getData()
	 */
	public function getData($cacheResource) {

		$data = array();
		
		// get userOptionID and skip if result empty
		$userOptionIDResult = User::getUserOptionID('birthday');
		if (empty($userOptionIDResult)) return $data;
		
		// get birthdays
		$sql = "SELECT useroptions.userID, useroptions.useroption".$userOptionIDResult." as birthday, user.userID, user.username
		FROM wcf" . WCF_N . "_user_option_value useroptions
		LEFT JOIN wcf" . WCF_N . "_user user
		ON (useroptions.userID = user.userID)
		WHERE useroptions.useroption".$userOptionIDResult." LIKE '%-".date('m')."-".date('d')."'
		LIMIT 0,".PORTAL_BIRTHDAYLIST_ITEMS;
		
		$result = WCF::getDB()->sendQuery($sql);
		
		while ($row = WCF::getDB()->fetchArray($result)) {
			$age = DateUtil::getAge($row['birthday']);
			$birthday = ($age >= 120) ? '' : $age;
			$row['age'] = $birthday;
			$data[] = $row;	
		}
		
        	return $data;
	}

}

?>